﻿Type=Class
Version=2
B4J=true
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
	Private switches() As JQueryElement
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	switches = Array As JQueryElement( _
		ws.GetElementById("btn0"), _
		ws.GetElementById("btn1"), _
		ws.GetElementById("btn2"), _
		ws.GetElementById("btn3"))
	For Each b As JQueryElement In switches
		b.SetHtml("false")
	Next
	'prepare the toggle buttons and set their state.
	For i = 0 To 7
		Dim state As Boolean = main.pface.GetLED(i).State
		ws.GetElementById("led" & i).RunMethod("toggles", Array As Object(CreateMap("on": state)))
	Next
	Main.connections.Put(Me, "")
End Sub

Public Sub SwitchStateChanged (index As Int, state As Boolean)
	switches(index).SetHtml(state)
	ws.Flush
End Sub

Private Sub WebSocket_Disconnected
	Main.connections.Remove(Me)
End Sub

Public Sub Led_Toggle(Params As Map)
	Dim id As String = Params.Get("id")
	Dim active As Boolean = Params.Get("active")
	Log(id & ", " & active)
	Main.pface.GetLED(id.SubString(3)).State = active
End Sub